| 導購 | 订阅 | 在线投稿
分享
 
 
 

JavaScript中try...catch和異常處理

來源:互聯網  2008-08-08 06:10:17  評論

在JavaScript可以使用try...catch來進行異常處理。例如: try {

foo.bar();

} catch (e) {

alert(e.name + " : " + e.message);

}

目前我們可能得到的系統異常主要包含以下6種:

EvalError: raised when an error occurs executing code in eval()

RangeError: raised when a numeric variable or parameter is outside of its valid range

ReferenceError: raised when de-referencing an invalid reference

SyntaxError: raised when a syntax error occurs while parsing code in eval()

TypeError: raised when a variable or parameter is not a valid type

URIError: raised when encodeURI() or decodeURI() are passed invalid parameters

上面的六種異常對象都繼承自Error對象。他們都支持以下兩種構造方法:

new Error();

new Error( " 異常信息 " );

手工抛出異常的方法如下:

try {

throw new Error( " Whoops! " );

} catch (e) {

alert(e.name + " : " + e.message);

}

如要判斷異常信息的類型,可在catch中進行判斷:

try {

foo.bar();

} catch (e) {

if (e instanceof EvalError) {

alert(e.name + " : " + e.message);

} else if (e instanceof RangeError) {

alert(e.name + " : " + e.message);

}

// etc

}

Error具有下面一些主要屬性:

description: 錯誤描述 (僅IE可用).

fileName: 出錯的文件名 (僅Mozilla可用).

lineNumber: 出錯的行數 (僅Mozilla可用).

message: 錯誤信息 (在IE下同description)

name: 錯誤類型.

number: 錯誤代碼 (僅IE可用).

stack: 像Java中的Stack Trace一樣的錯誤堆棧信息 (僅Mozilla可用).

因此爲了更好的了解錯誤信息我們可以將catch部分改爲如下形式:

try {

foo.bar();

} catch (e) {

if (browserType != BROWSER_IE) {

alert(

" name: " + e.name +

" \nmessage: " + e.message +

" \nlineNumber: " + e.lineNumber +

" \nfileName: " + e.fileName +

" \nstack: " + e.stack);

}

else {

alert(

" name: " + e.name +

" \nerrorNumber: " + (e.number & 0xFFFF ) +

" \nmessage: " + e.message " );

}

}

JavaScript中的throw命令事實上可以抛出任何對象,並且我們可以在catch接受到此對象。例如:

1 try {

2 throw new Date(); // 抛出當前時間對象

3 } catch (e) {

4 alert(e.toLocaleString()); // 使用本地格式顯示當前時間

5 }

在JavaScript可以使用try...catch來進行異常處理。例如: try { foo.bar(); } catch (e) { alert(e.name + " : " + e.message); } 目前我們可能得到的系統異常主要包含以下6種: EvalError: raised when an error occurs executing code in eval() RangeError: raised when a numeric variable or parameter is outside of its valid range ReferenceError: raised when de-referencing an invalid reference SyntaxError: raised when a syntax error occurs while parsing code in eval() TypeError: raised when a variable or parameter is not a valid type URIError: raised when encodeURI() or decodeURI() are passed invalid parameters 上面的六種異常對象都繼承自Error對象。他們都支持以下兩種構造方法: new Error(); new Error( " 異常信息 " ); 手工抛出異常的方法如下: try { throw new Error( " Whoops! " ); } catch (e) { alert(e.name + " : " + e.message); } 如要判斷異常信息的類型,可在catch中進行判斷: try { foo.bar(); } catch (e) { if (e instanceof EvalError) { alert(e.name + " : " + e.message); } else if (e instanceof RangeError) { alert(e.name + " : " + e.message); } // etc } Error具有下面一些主要屬性: description: 錯誤描述 (僅IE可用). fileName: 出錯的文件名 (僅Mozilla可用). lineNumber: 出錯的行數 (僅Mozilla可用). message: 錯誤信息 (在IE下同description) name: 錯誤類型. number: 錯誤代碼 (僅IE可用). stack: 像Java中的Stack Trace一樣的錯誤堆棧信息 (僅Mozilla可用). 因此爲了更好的了解錯誤信息我們可以將catch部分改爲如下形式: try { foo.bar(); } catch (e) { if (browserType != BROWSER_IE) { alert( " name: " + e.name + " \nmessage: " + e.message + " \nlineNumber: " + e.lineNumber + " \nfileName: " + e.fileName + " \nstack: " + e.stack); } else { alert( " name: " + e.name + " \nerrorNumber: " + (e.number & 0xFFFF ) + " \nmessage: " + e.message " ); } } JavaScript中的throw命令事實上可以抛出任何對象,並且我們可以在catch接受到此對象。例如: 1 try { 2 throw new Date(); // 抛出當前時間對象 3 } catch (e) { 4 alert(e.toLocaleString()); // 使用本地格式顯示當前時間 5 }
󰈣󰈤
王朝萬家燈火計劃
期待原創作者加盟
 
 
 
>>返回首頁<<
 
 
 
 
 熱帖排行
 
 
 
靜靜地坐在廢墟上,四周的荒凉一望無際,忽然覺得,淒涼也很美
© 2005- 王朝網路 版權所有